
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.27
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	VOID	259
#define	STRUCT	260
#define	UNION	261
#define	ENUM	262
#define	SIGNED	263
#define	UNSIGNED	264
#define	LONG	265
#define	SHORT	266
#define	INT	267
#define	FLOAT	268
#define	DOUBLE	269
#define	CHAR	270
#define	FIRST	271
#define	LAST	272
#define	CHECK	273
#define	CNULL	274
#define	TYPE	275
#define	ONERROR	276
#define	TOKEN	277
#define	NUMBER	278
#define	TYPETOKEN	279
#define	CCODE	280
#define	HCODE	281
#define	PUBLIC	282
#define	PRIVATE	283
#define	ARGUMENT	284
#define	VIRTUAL	285
#define	SIGNAL	286
#define	OVERRIDE	287

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <string.h>

#include "tree.h"

#define _(x) (x)
	
extern char *filename;
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static GList *typestack = NULL;
static int stars = 0;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_this = FALSE;

static GList *gtktypes = NULL;

void free(void *ptr);
int yylex(void);

extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ",str," at end of input",NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp,'\n')))
			*p='.';

		out=g_strconcat("Error: ",str," before '",tmp,"'",NULL);
		g_free(tmp);
	}

	fprintf(stderr,"%s:%d: %s\n",filename,line_no,out);
	g_free(out);
	
	exit(1);
}

static void
push_variable(char *name, int scope)
{
	Node *var;
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	
	var = new_variable(scope,type,name);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, char *oid, char *id, char *onerror,
	      GString *cbuf,int line_no)
{
	Node *node;
	Type *type;
       
	if(scope!=INIT_METHOD && scope!=CLASS_INIT_METHOD) {
		type = typestack->data;
		typestack = g_list_remove(typestack,typestack->data);
	} else {
		type = (Type *)new_type(0,g_strdup("void"));
	}
	
	node = new_method(scope,type,oid,gtktypes,id,funcargs,
			  onerror,cbuf,line_no);
	gtktypes = NULL;
	funcargs = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
push_funcarg(char *name)
{
	Node *node;
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	
	node = new_funcarg(type,name,checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(1,tn);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_this(char *this)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(1,g_strdup(((Class *)class)->otype));
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,this,ch);
	funcargs = g_list_prepend(funcargs, node);
}


#line 157 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		202
#define	YYFLAG		-32768
#define	YYNTBASE	48

#define YYTRANSLATE(x) ((unsigned)(x) <= 287 ? yytranslate[x] : 72)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    46,     2,     2,     2,     2,     2,     2,    37,
    38,    40,     2,    41,    47,     2,     2,     2,    43,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    36,    45,
    42,    44,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    34,    39,    35,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    15,    18,    20,    22,    27,
    32,    35,    38,    41,    43,    45,    47,    52,    57,    69,
    78,    82,    83,    87,    89,    91,    94,    97,   100,   102,
   105,   108,   110,   112,   114,   116,   119,   121,   123,   126,
   128,   131,   133,   135,   137,   139,   141,   144,   146,   151,
   155,   157,   169,   180,   192,   203,   214,   224,   234,   243,
   256,   266,   276,   282,   289,   292,   295,   299,   302,   303,
   305,   307,   311,   313,   317,   319,   322,   329,   332,   334,
   336,   338,   341,   344,   348,   352,   356,   360,   362
};

static const short yyrhs[] = {    49,
    50,    49,     0,    50,    49,     0,    49,    50,     0,    50,
     0,    49,    26,     0,    49,    27,     0,    26,     0,    27,
     0,    51,    34,    52,    35,     0,     3,    25,     4,    25,
     0,    52,    64,     0,    52,    53,     0,    52,    54,     0,
    64,     0,    53,     0,    54,     0,    28,    57,    23,    36,
     0,    29,    57,    23,    36,     0,    30,    55,    23,    23,
    23,    34,    26,    23,    34,    26,    36,     0,    30,    55,
    23,    23,    23,    34,    26,    36,     0,    37,    56,    38,
     0,     0,    23,    39,    56,     0,    23,     0,    58,     0,
    58,    61,     0,    10,    59,     0,     9,    59,     0,    59,
     0,    10,    16,     0,     9,    16,     0,    16,     0,    15,
     0,    14,     0,    23,     0,    60,    23,     0,    25,     0,
     5,     0,    11,    13,     0,    11,     0,    12,    13,     0,
    12,     0,    13,     0,     8,     0,     7,     0,     6,     0,
    40,    61,     0,    40,     0,    23,    37,    63,    38,     0,
    63,    41,    23,     0,    23,     0,    32,    18,    62,    57,
    23,    37,    66,    38,    65,    34,    26,     0,    32,    18,
    62,    57,    23,    37,    66,    38,    65,    36,     0,    32,
    17,    62,    57,    23,    37,    66,    38,    65,    34,    26,
     0,    32,    17,    62,    57,    23,    37,    66,    38,    65,
    36,     0,    32,    62,    57,    23,    37,    66,    38,    65,
    34,    26,     0,    32,    62,    57,    23,    37,    66,    38,
    65,    36,     0,    31,    57,    23,    37,    66,    38,    65,
    34,    26,     0,    31,    57,    23,    37,    66,    38,    65,
    36,     0,    33,    37,    25,    38,    57,    23,    37,    66,
    38,    65,    34,    26,     0,    28,    57,    23,    37,    66,
    38,    65,    34,    26,     0,    29,    57,    23,    37,    66,
    38,    65,    34,    26,     0,    23,    37,    23,    38,    36,
     0,    23,    37,    23,    38,    34,    26,     0,    22,    23,
     0,    22,    71,     0,    22,    34,    26,     0,    42,    43,
     0,     0,     5,     0,    23,     0,    23,    41,    67,     0,
    67,     0,    67,    41,    68,     0,    68,     0,    57,    23,
     0,    57,    23,    37,    19,    69,    38,     0,    69,    70,
     0,    70,     0,    20,     0,    21,     0,    44,    71,     0,
    45,    71,     0,    44,    42,    71,     0,    45,    42,    71,
     0,    42,    42,    71,     0,    46,    42,    71,     0,    24,
     0,    47,    24,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   175,   176,   177,   178,   181,   185,   189,   193,   199,   206,
   211,   212,   213,   214,   215,   216,   219,   222,   226,   251,
   275,   276,   279,   282,   288,   292,   299,   302,   305,   308,
   311,   314,   317,   320,   323,   326,   330,   333,   338,   341,
   344,   347,   350,   355,   358,   361,   366,   367,   370,   375,
   378,   384,   393,   402,   411,   420,   429,   438,   442,   446,
   450,   454,   458,   474,   493,   494,   495,   499,   500,   505,
   506,   516,   526,   529,   530,   533,   536,   541,   542,   545,
   549,   553,   557,   561,   565,   569,   573,   579,   580
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","VOID","STRUCT","UNION","ENUM","SIGNED","UNSIGNED","LONG","SHORT","INT",
"FLOAT","DOUBLE","CHAR","FIRST","LAST","CHECK","CNULL","TYPE","ONERROR","TOKEN",
"NUMBER","TYPETOKEN","CCODE","HCODE","PUBLIC","PRIVATE","ARGUMENT","VIRTUAL",
"SIGNAL","OVERRIDE","'{'","'}'","';'","'('","')'","'|'","'*'","','","'='","'1'",
"'>'","'<'","'!'","'-'","prog","ccodes","class","classdec","classcode","variable",
"argument","argflags","flaglist","type","type1","integer","tspecifier","stars",
"sigtype","tokenlist","method","onerror","funcargs","arglist","arg","checklist",
"check","number", NULL
};
#endif

static const short yyr1[] = {     0,
    48,    48,    48,    48,    49,    49,    49,    49,    50,    51,
    52,    52,    52,    52,    52,    52,    53,    53,    54,    54,
    55,    55,    56,    56,    57,    57,    58,    58,    58,    58,
    58,    58,    58,    58,    58,    58,    58,    58,    59,    59,
    59,    59,    59,    60,    60,    60,    61,    61,    62,    63,
    63,    64,    64,    64,    64,    64,    64,    64,    64,    64,
    64,    64,    64,    64,    65,    65,    65,    65,    65,    66,
    66,    66,    66,    67,    67,    68,    68,    69,    69,    70,
    70,    70,    70,    70,    70,    70,    70,    71,    71
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     2,     2,     1,     1,     4,     4,
     2,     2,     2,     1,     1,     1,     4,     4,    11,     8,
     3,     0,     3,     1,     1,     2,     2,     2,     1,     2,
     2,     1,     1,     1,     1,     2,     1,     1,     2,     1,
     2,     1,     1,     1,     1,     1,     2,     1,     4,     3,
     1,    11,    10,    11,    10,    10,     9,     9,     8,    12,
     9,     9,     5,     6,     2,     2,     3,     2,     0,     1,
     1,     3,     1,     3,     1,     2,     6,     2,     1,     1,
     1,     2,     2,     3,     3,     3,     3,     1,     2
};

static const short yydefact[] = {     0,
     0,     7,     8,     0,     4,     0,     0,     5,     6,     3,
     2,     0,     0,     1,     0,     0,     0,    22,     0,     0,
     0,     0,    15,    16,    14,    10,     0,    38,    46,    45,
    44,     0,     0,    40,    42,    43,    34,    33,    32,    35,
    37,     0,    25,    29,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     9,    12,    13,    11,     0,    31,
    28,    30,    27,    39,    41,     0,    48,    26,    36,     0,
    24,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    17,     0,    47,    18,     0,     0,    21,     0,     0,     0,
     0,    51,     0,     0,     0,     0,    63,    38,    35,     0,
     0,    73,    75,     0,    23,     0,     0,     0,     0,    49,
     0,     0,     0,    64,     0,    76,    69,     0,    69,     0,
    69,     0,     0,    50,     0,     0,    72,     0,     0,     0,
     0,    74,     0,     0,     0,     0,     0,    69,     0,     0,
    65,    88,     0,     0,    66,    68,     0,     0,     0,    20,
     0,    59,    69,    69,     0,     0,    80,    81,     0,     0,
     0,     0,     0,    79,    67,    89,    61,    62,     0,    58,
     0,     0,     0,    57,    69,     0,     0,    82,     0,    83,
     0,    77,    78,     0,     0,    55,     0,    53,    56,     0,
    86,    84,    85,    87,    19,    54,    52,     0,    60,     0,
     0,     0
};

static const short yydefgoto[] = {   200,
     4,     5,     6,    22,    23,    24,    48,    72,   100,    43,
    44,    45,    68,    53,    93,    25,   131,   101,   102,   103,
   163,   164,   145
};

static const short yypact[] = {     3,
   -23,-32768,-32768,    23,    69,   -25,    19,-32768,-32768,    69,
   104,   105,     2,   104,    36,    75,    75,    40,    75,    -5,
    62,    94,-32768,-32768,-32768,-32768,    34,-32768,-32768,-32768,
-32768,    81,   102,   126,   132,-32768,-32768,-32768,-32768,-32768,
-32768,    93,    80,-32768,   109,   133,   134,   135,   136,   137,
   137,   118,    75,   138,-32768,-32768,-32768,-32768,   123,-32768,
-32768,-32768,-32768,-32768,-32768,   111,    80,-32768,-32768,   113,
   125,   124,   142,   129,    75,    75,   144,   145,   131,    30,
-32768,    96,-32768,-32768,    96,   134,-32768,   147,    96,   148,
   149,-32768,   -22,   139,    75,   151,-32768,   140,   -21,   150,
   141,   143,-32768,   152,-32768,   146,   153,   155,   156,-32768,
   158,    96,   159,-32768,    75,   157,    33,    75,    33,   160,
    33,    96,    96,-32768,   161,   163,   143,   164,    -9,   154,
   162,-32768,   167,    29,    42,   165,   166,    33,    96,     1,
-32768,-32768,   169,   174,-32768,-32768,   176,   179,   172,-32768,
   181,-32768,    33,    33,   106,   170,-32768,-32768,   168,     9,
    20,   171,   -10,-32768,-32768,-32768,-32768,-32768,   183,-32768,
   107,   110,   185,-32768,    33,    24,    24,-32768,    24,-32768,
    24,-32768,-32768,   178,   186,-32768,   189,-32768,-32768,   182,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   191,-32768,   175,
   187,-32768
};

static const short yypgoto[] = {-32768,
    58,   184,-32768,-32768,   196,   197,-32768,    88,   -16,-32768,
   119,-32768,   122,   103,-32768,   198,  -114,   -81,    70,   108,
-32768,    59,  -107
};


#define	YYLAST		226


static const short yytable[] = {    42,
    46,     7,    49,   104,   133,     1,   135,   107,    12,   157,
   158,    50,    51,   141,   142,   110,   -71,    52,   111,   115,
   157,   158,    13,   155,   143,     1,    26,   182,     2,     3,
   125,   159,   142,   160,   161,   162,    78,   144,   171,   172,
   136,   137,   159,   142,   160,   161,   162,   142,     8,     9,
   177,   149,   178,   180,   129,   144,    59,   156,    90,    91,
   190,   179,    11,    96,   150,    97,   144,    14,   191,   192,
   144,   193,    27,   194,   130,   151,    47,   152,   113,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    39,    34,    35,    36,     2,     3,    60,    40,    54,    41,
    98,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39,    34,    35,    36,    66,    15,    62,    99,    67,
    41,    16,    17,    18,    19,    20,    21,    15,    55,     8,
     9,    69,    16,    17,    18,    19,    20,    21,    64,   173,
   185,   174,   186,   187,    65,   188,    81,    82,    84,    85,
    61,    63,    75,    76,    77,    70,    71,    73,    74,    52,
    80,    87,    79,    86,    88,    89,    92,    94,    95,   106,
   108,   109,   116,   105,   201,   112,   114,   -70,   117,   120,
   124,   126,   140,   118,   127,   134,   202,    10,    83,   119,
   121,   122,   123,   128,   165,   147,   146,   166,   138,   139,
   148,   167,   153,   154,   168,   169,   170,   175,   184,   176,
   189,   196,   181,   195,   197,   198,   199,    56,    57,    58,
     0,   183,     0,     0,     0,   132
};

static const short yycheck[] = {    16,
    17,    25,    19,    85,   119,     3,   121,    89,    34,    20,
    21,    17,    18,    23,    24,    38,    38,    23,    41,    41,
    20,    21,     4,   138,    34,     3,    25,    38,    26,    27,
   112,    42,    24,    44,    45,    46,    53,    47,   153,   154,
   122,   123,    42,    24,    44,    45,    46,    24,    26,    27,
    42,    23,   160,   161,    22,    47,    23,   139,    75,    76,
   175,    42,     5,    34,    36,    36,    47,    10,   176,   177,
    47,   179,    37,   181,    42,    34,    37,    36,    95,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    11,    12,    13,    26,    27,    16,    23,    37,    25,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    11,    12,    13,    23,    23,    16,    23,    40,
    25,    28,    29,    30,    31,    32,    33,    23,    35,    26,
    27,    23,    28,    29,    30,    31,    32,    33,    13,    34,
    34,    36,    36,    34,    13,    36,    36,    37,    36,    37,
    32,    33,    50,    51,    37,    23,    23,    23,    23,    23,
    38,    38,    25,    39,    23,    37,    23,    23,    38,    23,
    23,    23,    23,    86,     0,    37,    26,    38,    38,    34,
    23,    23,    19,    41,   115,    26,     0,     4,    67,    38,
    38,    37,    37,    37,    26,    34,    43,    24,    38,    37,
    34,    26,    38,    38,    26,    34,    26,    38,    26,    42,
    26,    26,    42,    36,    26,    34,    26,    22,    22,    22,
    -1,   163,    -1,    -1,    -1,   118
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.27.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 216 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 175 "parse.y"
{ ; ;
    break;}
case 2:
#line 176 "parse.y"
{ ; ;
    break;}
case 3:
#line 177 "parse.y"
{ ; ;
    break;}
case 4:
#line 178 "parse.y"
{ ; ;
    break;}
case 5:
#line 181 "parse.y"
{
			Node *node = new_ccode(FALSE,yyvsp[0].cbuf);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 6:
#line 185 "parse.y"
{
			Node *node = new_ccode(TRUE,yyvsp[0].cbuf);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 7:
#line 189 "parse.y"
{
			Node *node = new_ccode(FALSE,yyvsp[0].cbuf);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 8:
#line 193 "parse.y"
{
			Node *node = new_ccode(TRUE,yyvsp[0].cbuf);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 9:
#line 199 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 10:
#line 206 "parse.y"
{
			class = new_class(yyvsp[-2].id,yyvsp[0].id,NULL);
						;
    break;}
case 11:
#line 211 "parse.y"
{ ; ;
    break;}
case 12:
#line 212 "parse.y"
{ ; ;
    break;}
case 13:
#line 213 "parse.y"
{ ; ;
    break;}
case 14:
#line 214 "parse.y"
{ ; ;
    break;}
case 15:
#line 215 "parse.y"
{ ; ;
    break;}
case 16:
#line 216 "parse.y"
{ ; ;
    break;}
case 17:
#line 219 "parse.y"
{
			push_variable(yyvsp[-1].id,PUBLIC_SCOPE);
						;
    break;}
case 18:
#line 222 "parse.y"
{
			push_variable(yyvsp[-1].id,PRIVATE_SCOPE);
						;
    break;}
case 19:
#line 226 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,yyvsp[-9].list,yyvsp[-7].id,
						    yyvsp[-4].cbuf,yyvsp[-1].cbuf);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,yyvsp[-9].list,yyvsp[-7].id,
						    yyvsp[-1].cbuf,yyvsp[-4].cbuf);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 20:
#line 251 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,yyvsp[-6].list,yyvsp[-4].id,
						    yyvsp[-1].cbuf,NULL);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,yyvsp[-1].cbuf);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 21:
#line 275 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 22:
#line 276 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 23:
#line 279 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 24:
#line 282 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 25:
#line 288 "parse.y"
{
			Node *node = new_type(0,yyvsp[0].id);
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 26:
#line 292 "parse.y"
{
			Node *node = new_type(stars,yyvsp[-1].id);
			stars = 0;
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 27:
#line 299 "parse.y"
{
			yyval.id = g_strconcat("unsigned ",yyvsp[0].id,NULL);
						;
    break;}
case 28:
#line 302 "parse.y"
{
			yyval.id = g_strconcat("signed ",yyvsp[0].id,NULL);
						;
    break;}
case 29:
#line 305 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
						;
    break;}
case 30:
#line 308 "parse.y"
{
			yyval.id = g_strdup("unsigned char");
						;
    break;}
case 31:
#line 311 "parse.y"
{
			yyval.id = g_strdup("signed char");
						;
    break;}
case 32:
#line 314 "parse.y"
{
			yyval.id = g_strdup("char");
						;
    break;}
case 33:
#line 317 "parse.y"
{
			yyval.id = g_strdup("double");
						;
    break;}
case 34:
#line 320 "parse.y"
{
			yyval.id = g_strdup("float");
						;
    break;}
case 35:
#line 323 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 36:
#line 326 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id,yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
						;
    break;}
case 37:
#line 330 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 38:
#line 333 "parse.y"
{
			yyval.id = g_strdup("void");
						;
    break;}
case 39:
#line 338 "parse.y"
{
			yyval.id = "long int";
						;
    break;}
case 40:
#line 341 "parse.y"
{
			yyval.id = "long";
						;
    break;}
case 41:
#line 344 "parse.y"
{
			yyval.id = "short int";
						;
    break;}
case 42:
#line 347 "parse.y"
{
			yyval.id = "short";
						;
    break;}
case 43:
#line 350 "parse.y"
{
			yyval.id = "int";
						;
    break;}
case 44:
#line 355 "parse.y"
{
			yyval.id = "enum ";
						;
    break;}
case 45:
#line 358 "parse.y"
{
			yyval.id = "union ";
						;
    break;}
case 46:
#line 361 "parse.y"
{
			yyval.id = "struct ";
						;
    break;}
case 47:
#line 366 "parse.y"
{ stars++; ;
    break;}
case 48:
#line 367 "parse.y"
{ stars++; ;
    break;}
case 49:
#line 370 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes,yyvsp[-3].id);
						;
    break;}
case 50:
#line 375 "parse.y"
{
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
						;
    break;}
case 51:
#line 378 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
       						;
    break;}
case 52:
#line 384 "parse.y"
{
			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(SIGNAL_LAST_METHOD,NULL,
				      yyvsp[-6].id, yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-10].line);
									;
    break;}
case 53:
#line 393 "parse.y"
{
			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(SIGNAL_LAST_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[-1].id, NULL,yyvsp[-9].line);
									;
    break;}
case 54:
#line 402 "parse.y"
{
			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(SIGNAL_FIRST_METHOD, NULL,
				      yyvsp[-6].id, yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-10].line);
									;
    break;}
case 55:
#line 411 "parse.y"
{
			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(SIGNAL_FIRST_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, NULL,yyvsp[-9].line);
									;
    break;}
case 56:
#line 420 "parse.y"
{
			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(SIGNAL_LAST_METHOD, NULL,
				      yyvsp[-6].id, yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-9].line);
									;
    break;}
case 57:
#line 429 "parse.y"
{
			if(!has_this) {
				yyerror(_("signal without 'this' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(SIGNAL_LAST_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, NULL,yyvsp[-8].line);
									;
    break;}
case 58:
#line 438 "parse.y"
{
			push_function(VIRTUAL_METHOD, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line);
									;
    break;}
case 59:
#line 442 "parse.y"
{
			push_function(VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, NULL,yyvsp[-7].line);
									;
    break;}
case 60:
#line 446 "parse.y"
{
			push_function(OVERRIDE_METHOD, yyvsp[-9].id,
				      yyvsp[-6].id, yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-11].line);
									;
    break;}
case 61:
#line 450 "parse.y"
{
			push_function(PUBLIC_SCOPE, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line);
								;
    break;}
case 62:
#line 454 "parse.y"
{
			push_function(PRIVATE_SCOPE, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line);
								;
    break;}
case 63:
#line 458 "parse.y"
{
			if(strcmp(yyvsp[-4].id,"init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(INIT_METHOD, NULL, yyvsp[-4].id, 
					      NULL, NULL,yyvsp[-3].line);
			} else if(strcmp(yyvsp[-4].id,"class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, NULL,yyvsp[-3].line);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 64:
#line 474 "parse.y"
{
			if(strcmp(yyvsp[-5].id,"init")==0) {
				push_init_arg(yyvsp[-3].id,FALSE);
				push_function(INIT_METHOD, NULL,
					      yyvsp[-5].id, NULL, yyvsp[0].cbuf,yyvsp[-4].line);
			} else if(strcmp(yyvsp[-5].id,"class_init")==0) {
				push_init_arg(yyvsp[-3].id,TRUE);
				push_function(CLASS_INIT_METHOD, NULL, 
					      yyvsp[-5].id, NULL, yyvsp[0].cbuf,yyvsp[-4].line);
			} else {
				g_free(yyvsp[-5].id);
				g_free(yyvsp[-3].id);
				g_string_free(yyvsp[-3].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 65:
#line 493 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 66:
#line 494 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 67:
#line 495 "parse.y"
{
			yyval.id = (yyvsp[0].cbuf)->str;
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 68:
#line 499 "parse.y"
{ ; ;
    break;}
case 69:
#line 500 "parse.y"
{ yyval.id = NULL; ;
    break;}
case 70:
#line 505 "parse.y"
{ has_this = FALSE; ;
    break;}
case 71:
#line 506 "parse.y"
{
			has_this = TRUE;
			if(strcmp(yyvsp[0].id,"this")==0)
				push_this(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 72:
#line 516 "parse.y"
{
			has_this = TRUE;
			if(strcmp(yyvsp[-2].id,"this")==0)
				push_this(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 73:
#line 526 "parse.y"
{ has_this = FALSE; ;
    break;}
case 74:
#line 529 "parse.y"
{ ; ;
    break;}
case 75:
#line 530 "parse.y"
{ ; ;
    break;}
case 76:
#line 533 "parse.y"
{
			push_funcarg(yyvsp[0].id);
								;
    break;}
case 77:
#line 536 "parse.y"
{
			push_funcarg(yyvsp[-4].id);
								;
    break;}
case 78:
#line 541 "parse.y"
{ ; ;
    break;}
case 79:
#line 542 "parse.y"
{ ; ;
    break;}
case 80:
#line 545 "parse.y"
{
			Node *node = new_check(NULL_CHECK,NULL);
			checks = g_list_append(checks,node);
					;
    break;}
case 81:
#line 549 "parse.y"
{
			Node *node = new_check(TYPE_CHECK,NULL);
			checks = g_list_append(checks,node);
					;
    break;}
case 82:
#line 553 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 83:
#line 557 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 84:
#line 561 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 85:
#line 565 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 86:
#line 569 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 87:
#line 573 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 88:
#line 579 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 89:
#line 580 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 542 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 586 "parse.y"

